* Create the DBFListener object and use it to run the report.

loListener = newobject('DBFListener', 'DBFListener.PRG')
report form Customers object loListener

* Show the report in our custom previewer.

loForm = newobject('SFPreviewForm', 'SFPreview.vcx')
with loForm
	.cOutputAlias = loListener.cOutputAlias
	.Caption      = 'Customer Report'
	.oListener    = loListener
	.FirstPage()
endwith

* Bind to the object click events so we can handle them.

loHandler = createobject('ClickHandler')
bindevent(loForm, 'ObjectClicked',      loHandler, 'OnClick')
bindevent(loForm, 'ObjectRightClicked', loHandler, 'OnRightClick')

* Display the preview form.

loForm.Show(1)

* A class to handle object clicks.

define class ClickHandler as Custom
	procedure OnClick(toObject, toForm)
		local lcObject
		toObject.Top    = toObject.Top/10
		toObject.Left   = toObject.Left/10
		toObject.Width  = toObject.Width/10
		toObject.Height = toObject.Height/10
		lcObject = transform(toObject.RecordNumber)
		toForm.AddHighlightedItem(lcObject, toObject.Page)
		toForm.DrawPage()
	endproc

	procedure OnRightClick(toObject, toForm)
		local lcObject
		lcObject = transform(toObject.RecordNumber)
		toForm.oHighlightedItems.Remove(lcObject)
		toForm.DrawPage()
	endproc
enddefine
