***************************************************
* WebmailClient
***************************************************
DEFINE CLASS WebmailClient As Session
#INCLUDE hotmail.h
	http=0
	xmlGateway=0
	xmlFolders=0
	folders=0  && collection
	email=""
	pwd=""
	response=""
	statustext=""
	responseheaders=""
	errorno=0
	errormessage=""

PROCEDURE Init(cEmail, cPwd)
	LOCAL ex As Exception
	TRY
		THIS.http = CREATEOBJECT(;
			"MSXML2.ServerXMLHTTP")
		THIS.xmlGateway = CREATEOBJECT(;
			"Microsoft.XMLDOM")
		THIS.xmlFolders = CREATEOBJECT(;
			"Microsoft.XMLDOM")
		THIS.folders = CREATEOBJECT("Collection")
	CATCH TO ex
	ENDTRY

	IF VARTYPE(m.ex)="O" Or;
		NOT THIS.ConnectTo(cEmail, cPwd)
		RETURN .F.
	ENDIF

PROCEDURE ConnectTo(cEmail, cPwd)
	LOCAL cServer
	THIS.email = LOWER(ALLTRIM(m.cEmail))
	THIS.pwd = LOWER(ALLTRIM(m.cPwd))

	DO CASE
	CASE "@hotmail.com" $ THIS.email
		cServer = URL_HOTMAIL
	CASE "@msn.com" $ cEmail
		cServer = URL_MSN
	OTHERWISE
	* invalid email account
		RETURN .F.
	ENDCASE

	* Connecting to Hotmail server...
	THIS.SendPropfind(cServer, XML_GATEWAY)
	
	IF THIS.response != RESPONSE_OK
	* failed to connect
		RETURN .F.
	ENDIF
	
	* load the response to xml parser
	THIS.xmlGateway.Load(THIS.http.ResponseXml)
RETURN THIS.GetFolders()

PROCEDURE GetFolders
* reads available folders and populates
* a collection of WebmailFolder objects
	= ClearCollection(THIS.folders)

	LOCAL cFoldersHref, xmlFolder,;
		nFolderCount, nFolderIndex, oFolder

	cFoldersHref = THIS.xmlGateway.;
		SelectSingleNode(MSGFOLDERROOT_NODE).Text

	THIS.SendPropfind(m.cFoldersHref, XML_FOLDERS)
	IF THIS.response <> RESPONSE_OK
		RETURN .F.
	ENDIF
	
	THIS.xmlFolders.Load(THIS.http.ResponseXml)

	nFolderCount = THIS.xmlFolders.;
		SelectSingleNode(MULTISTATUS).;
		ChildNodes.Length

	FOR nFolderIndex=0 TO nFolderCount-1
		xmlFolder = THIS.xmlFolders.;
			SelectSingleNode(MULTISTATUS).;
			ChildNodes(nFolderIndex)

		oFolder = CREATEOBJECT("WebmailFolder",;
			THIS, xmlFolder)

		THIS.folders.Add(oFolder,;
			oFolder.foldername)

		oFolder=Null
	NEXT

FUNCTION GetInboxHref
RETURN THIS.xmlGateway.SelectSingleNode(;
	FOLDERINBOX_NODE).Text

FUNCTION GetSentHref
RETURN THIS.xmlGateway.SelectSingleNode(;
	FOLDERSENT_NODE).Text

FUNCTION GetSendHref
RETURN THIS.xmlGateway.SelectSingleNode(;
	SENDMESSAGE_NODE).Text

FUNCTION GetTrashHref
RETURN THIS.xmlGateway.SelectSingleNode(;
	TRASHFOLDER_NODE).Text

PROCEDURE GetFolder(cFoldername) As WebmailFolder
	cFoldername = LOWER(ALLTRIM(m.cFoldername))
	LOCAL oFolder As WebmailFolder
	FOR EACH oFolder IN THIS.folders
		IF LOWER(ALLTRIM(oFolder.foldername))==;
			m.cFoldername
			RETURN oFolder
		ENDIF
	NEXT
	oFolder=Null
RETURN Null

PROCEDURE EmptyTrashFolder
	LOCAL oTrashFolder, oMessage, xmlBody
	oTrashFolder = THIS.GetFolder(TRASHFOLDER_NAME)

	oTrashFolder.GetMessageEnvelopes
	IF oTrashFolder.messages.Count = 0
		RETURN .T.
	ENDIF
	
	xmlBody=""
	FOR EACH oMessage IN oTrashFolder.messages
		xmlBody = xmlBody + CHR(9) + "<D:href>" +;
			oMessage.msgid + "</D:href>" + CRLF
	NEXT

	xmlBody = STRTRAN(XML_DELETEMESSAGE, "###",;
		m.xmlBody)
	THIS.SendHttpRequest("BDELETE",;
		oTrashFolder.href, "", m.xmlBody)
RETURN (THIS.response = RESPONSE_OK)

PROCEDURE SendEmail
LPARAMETERS cRecipient, cSubject, cBody, lSaveSent

	LOCAL href, cMessage, cHeaders
	
	* SendMessage url on Hotmail
	href = THIS.GetSendHref()

	* assembling the message
	cMessage = 'MAIL FROM:<' +;
		THIS.email + '>' + CRLF +;
		'RCPT TO:<' + cRecipient + '>' + CRLF +;
		'' + CRLF +;
		'From: <' + THIS.email + '>' + CRLF +;
		'To: <' + m.cRecipient + '>' + CRLF +;
		'Subject: ' + m.cSubject + CRLF +;
		'Date: ' + TTOC(DATETIME()) + CRLF +;
		'MIME-Version: 1.0' + CRLF +;
		'Content-Type: text/plain; ' +;
			'charset="Windows-1252"' + CRLF +;
		'X-Mailer: ' + VERSION() + CRLF +;
		'' + CRLF +;
		cBody

	* additional HTTP headers
	cHeaders = "Content-Type: message/rfc821;" +;
		"SAVEINSENT: " + IIF(m.lSaveSent, "t","f")

	* sending the message
	THIS.SendHttpRequest("POST", m.href,;
		m.cHeaders, m.cMessage)

RETURN (THIS.response=RESPONSE_OK)

PROCEDURE SendPropfind(href, xml)
THIS.SendHttpRequest(PROPFIND, m.href,;
	"Cache-Control: no-cache;" +;
	"Content-Type: text/xml", m.xml)

PROCEDURE SendProppatch(href, xml)
THIS.SendHttpRequest(PROPPATCH, m.href,;
	"Cache-Control: no-cache;" +;
	"Content-Type: text/xml", m.xml)

PROCEDURE SendHttpRequest
LPARAMETERS cMethod, href,cHeaders, cBody)
	STORE "" TO THIS.response, THIS.statustext,;
		THIS.responseheaders

	LOCAL ex As Exception
	WITH THIS.http
		TRY
			.Open(cMethod, m.href, 0,;
				THIS.email, THIS.pwd)
		CATCH TO ex
		ENDTRY
		
		IF VARTYPE(m.ex) = "O"
			THIS.errorno = ex.ErrorNo
			THIS.errormessage = ex.Message
			RETURN .F.
		ENDIF

		THIS.AddHeaders(cHeaders)

		TRY
			.Send(m.cBody)
			THIS.response = SUBSTR(;
				.GetResponseHeader(X_DAV_ERROR),1,3)
			THIS.statustext = THIS.http.StatusText
			THIS.responseheaders =;
				THIS.http.GetAllResponseHeaders()
		CATCH
		ENDTRY

		IF VARTYPE(m.ex) = "O"
			THIS.errorno = ex.ErrorNo
			THIS.errormessage = ex.Message
			RETURN .F.
		ENDIF
	ENDWITH

PROTECTED PROCEDURE AddHeaders(cHeaders)
* append additional headers to an open request
	IF EMPTY(cHeaders)
		RETURN
	ENDIF

	LOCAL nHeaderIndex, cHeader, nPos
	= ALINES(arrHeaders, cHeaders, ";")

	FOR nHeaderIndex=1 TO ALEN(arrHeaders)
		cHeader = arrHeaders[nHeaderIndex]
		nPos = AT(":", cHeader)
		TRY
			THIS.http.SetRequestHeader(;
				SUBSTR(cHeader, 1, nPos-1),;
				SUBSTR(cHeader, nPos+1))
		CATCH
		ENDTRY
	NEXT
ENDDEFINE

DEFINE CLASS WebmailFolder As Session
	webmail=Null
	href=""
	foldername=""
	specialfolder=.F.
	messagecount=0
	unreadcount=0
	messages=0  && collection

PROCEDURE Init(oWebmail, xmlFolder)
	THIS.webmail = m.oWebmail

	THIS.href = ssn(xmlFolder, "D:href")
	THIS.foldername = ssn(xmlFolder,;
		FOLDER_PROP_SPECIAL)

	IF NOT EMPTY(THIS.foldername)
		THIS.specialfolder = .T.
	ELSE
		THIS.foldername = ssn(xmlFolder,;
			FOLDER_PROP_DISPLAYNAME)
		THIS.specialfolder = .F.
	ENDIF

	THIS.messagecount = INT(VAL(ssn(xmlFolder,;
		FOLDER_PROP_VISIBLECOUNT)))
	THIS.unreadcount = INT(VAL(ssn(xmlFolder,;
		FOLDER_PROP_UNREADCOUNT)))

	THIS.messages = CREATEOBJECT("Collection")

PROCEDURE GetMessageEnvelopes
	= ClearCollection(THIS.messages)

	THIS.webmail.SendPropfind(THIS.href,;
		XML_MESSAGES)
	IF THIS.webmail.response != RESPONSE_OK
		RETURN
	ENDIF
	
	LOCAL xmlMessages, xmlMessage, nMessageCount,;
		nMessageIndex
	xmlMessages = CreateObject("Microsoft.XMLDOM")
	WITH xmlMessages
		.Load(THIS.webmail.http.ResponseXml)
		nMessageCount = .SelectSingleNode(;
			MULTISTATUS).ChildNodes.Length

		FOR nMessageIndex=0 TO nMessageCount-1
			xmlMessage = .SelectSingleNode(;
				MULTISTATUS).ChildNodes(;
				nMessageIndex)

			oMessage = CREATEOBJ("WebmailMessage",;
				THIS, xmlMessage)
			THIS.messages.Add(oMessage,;
				oMessage.msgid)
			oMessage = Null
		NEXT
	ENDWITH

PROCEDURE GetMessage(cMsgID)
	LOCAL oMessage As WebmailMessage
	TRY
		oMessage = THIS.messages.Item(m.cMsgID)
	CATCH
	ENDTRY
RETURN m.oMessage

ENDDEFINE

DEFINE CLASS WebmailMessage As Session
	folder=Null
	href=""
	msgid=""
	readstatus=.F.
	sender=""
	recipient=""
	subject=""
	created=""
	contentlength=0
	rawcontent=""
	rawheaders=""
	headers=0

PROCEDURE Init(oFolder, xmlMessage)
	THIS.headers = CREATEOBJECT("Collection")
	THIS.folder = m.oFolder

	THIS.href = ssn(xmlMessage, "D:href")
	THIS.msgid = SUBSTR(THIS.href,;
		RAT("/",THIS.href)+1)

	THIS.readstatus = (ssn(xmlMessage,;
		MESSAGE_PROP_READ)="1")
	THIS.sender = ssn(xmlMessage,;
		MESSAGE_PROP_FROM)
	THIS.recipient = ssn(xmlMessage,;
		MESSAGE_PROP_TO)
	THIS.subject = ssn(xmlMessage,;
		MESSAGE_PROP_SUBJECT)
	THIS.created = ssn(xmlMessage,;
		MESSAGE_PROP_DATE)
	THIS.contentlength = VAL(ssn(xmlMessage,;
		MESSAGE_PROP_CONTENTLENGTH))

PROCEDURE GetMessageContent
	= ClearCollection(THIS.headers)
	LOCAL cResponseText, nPos

	THIS.folder.webmail.SendHttpRequest("GET",;
		THIS.href, "", "")

	IF THIS.folder.webmail.response = RESPONSE_OK
		cResponseText =;
			THIS.folder.webmail.http.ResponseText
		nPos = AT(dCRLF, cResponseText)
		THIS.rawcontent = SUBSTR(cResponseText,;
			nPos+4)
		THIS.rawheaders = SUBSTR(cResponseText,;
			1, nPos)

		THIS.ParseHeaders
	ELSE
		STORE "" TO THIS.rawheaders,;
			THIS.rawcontent
	ENDIF

PROCEDURE ParseHeaders
	LOCAL cHeader, oHeader, nHeaderCount,;
		nHeaderIndex
	nHeaderCount = ALINES(arrHeaders,;
		THIS.rawheaders)

	FOR nHeaderIndex=1 TO nHeaderCount
		cHeader = arrHeaders[nHeaderIndex]
		IF INLIST(ASC(cHeader), 9,32)
			oHeader.headervalue =;
				oHeader.headervalue +;
				STRTRAN(ALLTRIM(cHeader),;
				CHR(9), " ")
		ELSE
			oHeader = CREATEOBJECT(;
				"MessageHeader", m.cHeader)
			THIS.headers.Add(oHeader)
		ENDIF
	NEXT
	RELEASE arrHeaders

PROCEDURE GetHeaderValue(cHeader)
	cHeader = STRTRAN(UPPER(ALLTRIM(m.cHeader)),;
		":","")
	LOCAL oHeader
	FOR EACH oHeader IN THIS.headers
		IF UPPER(ALLTRIM(oHeader.headername))==;
			m.cHeader
			RETURN oHeader.headervalue
		ENDIF
	NEXT
RETURN ""

PROCEDURE SetReadStatus(lStatus)
* sets Read/Unread status for the message
	LOCAL cReadStatus
	cReadStatus = STRTRAN(XML_SETREADSTATUS,;
		"###", IIF(m.lStatus, "1", "0"))
	WITH THIS.folder.webmail
		.SendProppatch(THIS.href, m.cReadStatus)
		IF .response = RESPONSE_OK
			THIS.readstatus = m.lStatus
		ENDIF
	ENDWITH

PROCEDURE DeleteMessage
	LOCAL href
	href = THIS.folder.webmail.GetTrashHref()
RETURN THIS.MoveMessage(m.href)

PROCEDURE MoveMessage(cDstHref)
	LOCAL cHeaders
	cHeaders = "Destination: " + cDstHref +;
		THIS.msgid + ";Allow-Rename: t"

	WITH THIS.folder.webmail
		.SendHttpRequest("MOVE",;
			THIS.href, cHeaders, "")
		RETURN (.response = RESPONSE_OK)
	ENDWITH

ENDDEFINE

DEFINE CLASS MessageHeader As Session
	headername=""
	headervalue=""

PROCEDURE Init(cHeader)
	LOCAL nPos
	nPos = AT(":", cHeader)
	THIS.headername = ALLTRIM(SUBSTR(cHeader,;
		1, nPos-1))
	THIS.headervalue = ALLTRIM(SUBSTR(cHeader,;
		nPos+1))
ENDDEFINE

**************** static functions ****************
FUNCTION ssn(oParent, cPath)
	LOCAL oNode
	oNode = oParent.SelectSingleNode(m.cPath)
RETURN Iif(VARTYPE(oNode)="O", oNode.Text, "")

PROCEDURE ClearCollection(oCollection)
	DO WHILE oCollection.Count > 0
		oCollection.Remove(1)
	ENDDO
